﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BenLincoln.TheLostWorlds.CDHashes
{
    public class SoulReaver2AirForgeHash : CDHash
    {
        public SoulReaver2AirForgeHash()
            : base()
        {
        }

        // This one is nearly all Andrew's work - it stymied me for so long I'd given up
        public override byte[] GetHashBytes(string input, bool hashRawText)
        {
            uint nameHash = 0;
            uint s4 = 0;
            uint s5 = 0;
            uint s6 = 0;
            uint fp = 0;
            uint s7 = 0;
            string inVal = input;

            uint v0 = (uint)inVal.Length;
            uint s3 = v0; // String length
            uint a0 = s5; // First character
            uint a1 = '.';
            // strchr returns a pointer to the first occurance of '.', but this could return -1
            v0 = (uint)inVal.IndexOf((char)a1, 0);
            int s2 = (int)s3 + -1; // Last character including extension
            uint s1 = v0; // Position of '.'
            uint s0 = 0; // Extension index
            if (s1 != 0) // Really (s0 != -1)
            {
                s1 = s1 + 1; // Position of extension
                s3 = s3 - 5; // Last character before '.'
                string[] HashExtensions = { "drm", "vrm", "raw", "smp", "snd", "smf", "snf" };
                while (true)
                {
                    v0 = (s0 < 7u) ? 1u : 0u; // Is extension index less than HashExtensions.Length
                    bool inRange = (v0 != 0);
                    // Multiplying by 4 would get HashExtensions[s0] in MIPS/C++
                    // If used on HashExtensions in C#, it would just be v0 = s0;
                    v0 = s0 << 2;
                    if (inRange)
                    {
                        a1 = 0; // a1 = HashExtensions[0];
                        a0 = s1; // Position of extension
                        a1 = a1 + v0; // a1 = HashExtensions[s0];
                        // strcasecmp returns 0 if true, but this would return true
                        v0 = (inVal.EndsWith(HashExtensions[s0], StringComparison.InvariantCultureIgnoreCase)) ? 0u : 1u;
                        if (v0 != 0)
                        {
                            s0 = s0 + 1;
                            continue;
                        }

                        fp = s0;
                    }

                    v0 = 6;
                    v0 = (v0 < s0) ? 1u : 0u; // Is s0 out of range?
                    if (v0 == 0) // Is s0 in range?
                    {
                        s2 = (int)s3; // Last character before '.'
                    }
                    // s2 does not change
                    //else
                    //{
                    //    s2 = s2; // Last character including extension
                    //}
                    break;
                }
            }
            // Is last character index less than 0, considering s2 was length - 1?
            v0 = (s2 < 0) ? 1u : 0u;
            uint v1 = s7 << 15;
            if (v0 == 0)
            {
                a0 = s5 + (uint)s2; // First character index + Last character index
                v1 = '\\';
                v0 = inVal[(int)a0]; // Get the last character
                // If the last character is '\\' it will be a folder, not a file, so skip it
                bool isFile = (v0 != v1);
                v1 = s7 << 15;
                if (isFile)
                {
                    uint a3 = 0xFFFFFFDF;
                    uint a2 = '\\';
                    a1 = inVal[(int)a0]; // Get the last character

                    while (true)
                    {
                        v0 = a1 - 'a';
                        // If v0 went negative, then the unsigned integer would be huge,
                        // so effectively this checks if (v0 >= 'a' && v0 <= 'z')
                        v0 = (v0 < 0x001A) ? 1u : 0u;
                        if (v0 != 0)
                        {
                            a1 = a1 & a3; // Convert to uppercase.
                        }
                        v0 = a1 - 26;
                        s2 -= 1;
                        v0 = v0 << 24;
                        a0 = a0 - 1;

                        ////////////////////////////////////////////////////////////////////////////

                        //a1 = (uint)((int)v0 >> 24);
                        //a1 = v0 >> 24;
                        // emulate shift-right-arithmetic operation
                        uint a1Buffer1;
                        uint a1Buffer2;
                        a1Buffer1 = v0;
                        a1Buffer2 = v0;
                        a1Buffer1 &= 0x80000000;
                        // arithmetic bit-shift does not ignore the leftmost bit
                        //a1Buffer2 &= 0x7FFFFFFF;
                        a1 = (a1Buffer2 >> 24) | a1Buffer1;
                        //a1 = v0 / 16777216;

                        ////////////////////////////////////////////////////////////////////////////

                        // Is last character index less than 0?
                        v1 = (s2 < 0) ? 1u : 0u;
                        v0 = a1 * s4;
                        s7 = s7 + a1;
                        s4 = s4 + 1;
                        s6 = s6 ^ v0;

                        if (v1 != 0)
                        {
                            break;
                        }

                        v0 = inVal[(int)a0]; // Get the last character
                        if (v0 != a2)
                        {
                            a1 = inVal[(int)a0]; // Get the last character
                            continue;
                        }

                        v1 = s7 << 15;
                        break;
                    }
                }

                v0 = s4 << 27;
                a0 = s6 << 3;
                v0 = v0 | v1;
                v0 = v0 | a0;
                v0 = v0 | fp;
            }

            nameHash = v0;

            return UIntToByteArray(nameHash);
        }

 
    }
}
