﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BenLincoln.TheLostWorlds.CDHashes
{
    public class SoulReaverAlphaHash : CDHash
    {
        public SoulReaverAlphaHash()
            : base()
        {
        }

        public override byte[] GetHashBytes(string input, bool hashRawText)
        {
            string inVal = input;

            uint charsRead = 0;
            int iVar6 = 0;
            int iVar7 = 0;
            uint uVar8 = 0;
            uint uVar10 = 0;
            uint currentLetter = 0;
            int index = 0;
            uint extID = 0;
            uint hashName = 0;
            if (hashRawText)
            {
                index = inVal.Length - 1;
            }
            else
            {
                string extension = inVal.Substring(inVal.LastIndexOf('.') + 1).ToLower();
                string[] extensions = { "drm", "crm", "tim", "smp", "snd", "smf", "snf" };
                for (index = 0; index < extensions.Length; index++)
                {
                    if (extension.Equals(extensions[index]))
                    {
                        extID = (uint)index;
                        break;
                    }
                }
                if (index < 7)
                {
                    index = inVal.Length - 5;
                }
                else
                {
                    index = inVal.Length - 1;
                }
            }
            while (index >= 0)
            {
                currentLetter = (uint)inVal[index];
                if (currentLetter >= 'a' && currentLetter <= 'z')
                {
                    currentLetter &= 0xDF;
                }
                currentLetter -= 0x1A;
                currentLetter &= 0xFF;
                
                uVar10 = (uint)(currentLetter * iVar6);
                iVar7 = (int)(iVar7 + currentLetter);
                iVar6 = iVar6 + 1;
                uVar8 = uVar8 ^ uVar10;

                charsRead++;
                index--;
            }

            currentLetter = (uint)(iVar6 * 0x8000000);

            hashName = currentLetter | (uint)iVar7 << 0xf | uVar8 << 3 | extID;

            return UIntToByteArray(hashName);
        }
    }
}
