﻿// BenLincoln.TheLostWorlds.CDHashes
// Copyright 2018 Ben Lincoln
// https://www.thelostworlds.net/
//

// This file is part of BenLincoln.TheLostWorlds.CDHashes.

// BenLincoln.TheLostWorlds.CDHashes is free software: you can redistribute it and/or modify
// it under the terms of version 3 of the GNU General Public License as published by
// the Free Software Foundation.

// BenLincoln.TheLostWorlds.CDHashes is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with BenLincoln.TheLostWorlds.CDHashes (in the file LICENSE.txt).  
// If not, see <http://www.gnu.org/licenses/>.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/* Hashing algorithm used in the Soul Reaver "Proto1" (Lighthouse) demo from 1998 */
/* Also used in Akuji: the Heartless, etc. */

namespace BenLincoln.TheLostWorlds.CDHashes
{
    public class SoulReaverProto1DemoHash : CDHash
    {
        public SoulReaverProto1DemoHash()
            : base()
        {
        }

        public override byte[] GetHashBytes(string input, bool hashRawText)
        {
            int charNum = 0;
            uint v1 = 0;
            uint t0 = 0;
            uint a2 = 0;
            uint a3 = 0;
            uint v0 = 0;
            byte[] chars = ASCIIEncoding.ASCII.GetBytes(input);


            while (charNum < chars.Length)
            {
                uint a1 = (uint)chars[charNum];
                v0 = (a1 + 0xff9f) & 0xffff;
                a2 = a1;
                if (v0 < 0x1a)
                {
                    a2 = a1 & 0xdf;
                }
                v0 = a2 & 0xff;
                uint lo = v0 * a3;
                v1 = v1 + v0;
                a3++;
                uint t1 = lo;
                t0 = t0 ^ t1;
                charNum++;
            }

            //uint dummy = 0;

            v0 = a3 << 24;
            v1 = v1 << 12;
            v0 = v0 | v1;
            v0 = v0 | t0;

            return UIntToByteArray(v0);
        }
    }
}
